Project Chrono: chrono::fea::ChLinkNodeFace Class Reference

Public Member Functions | List of all members
chrono::fea::ChLinkNodeFace Class Reference
Chrono::Engine » Finite Element Analysis » Constraints

## Description

Constraint between an xyz FEA node (point) and a triangular face given by three xyz FEA nodes The triangular face element is assumed to have linear shape function (e.g., the face of a tetrahedron or a triangular shell).

The node can be offset respect to the face.

`#include <ChLinkNodeFace.h>`

Inheritance diagram for chrono::fea::ChLinkNodeFace:
[legend]
Collaboration diagram for chrono::fea::ChLinkNodeFace:
[legend]

## Public Member Functions
| ChLinkNodeFace (const ChLinkNodeFace &other)
virtual ChLinkNodeFace * | Clone () const override
| "Virtual" copy constructor (covariant return type).
virtual unsigned int | GetNumAffectedCoords () override
| Get the number of scalar variables affected by constraints in this link.
virtual unsigned int | GetNumConstraintsBilateral () override
| Number of scalar constraints.
ChFrame | GetFrameNodeAbs () const
| Return the link frame, expressed in absolute coordinates.
virtual int | Initialize (std::shared_ptr< ChNodeFEAxyz > anodeA, std::shared_ptr< ChNodeFEAxyz > anodeB1, std::shared_ptr< ChNodeFEAxyz > anodeB2, std::shared_ptr< ChNodeFEAxyz > anodeB3)
| Initialize this constraint, given the node and the triangle to join.
virtual void | SetAreaCoords (const double ms2, const double ms3)
| Set the area coordinates to specify where the point A is connected on triangle.
virtual void | GetAreaCoords (double &ms2, double &ms3) const
| Get the area coordinates, as set with respect to B2 and B3.
virtual void | SetOffset (const double md)
| Set an optional offset of the point with respect to triangle, along triangle normal.
virtual double | GetOffset (double md) const
| Get the imposed offset of the point with respect to triangle.
std::shared_ptr< fea::ChNodeFEAxyz > | GetNode () const
| Get the connected xyz node (point).
std::array< std::shared_ptr< fea::ChNodeFEAxyz >, 3 > | GetTriangle () const
| Get the connected triangle.
ChVector3d | GetReactionOnNode () const
| Get the reaction force considered as applied to the node, in abs coords.
ChVector3d | GetReactionOnTriangle () const
| Get the reaction force considered as applied to the triangle, in abs coords.
virtual void | Update (double mytime, bool update_assets=true) override
| Update all auxiliary data of the gear transmission at given time.
virtual void | ArchiveOut (ChArchiveOut &archive_out) override
| Method to allow serialization of transient data to archives.
virtual void | ArchiveIn (ChArchiveIn &archive_in) override
| Method to allow deserialization of transient data from archives.
virtual void | IntStateGatherReactions (const unsigned int off_L, ChVectorDynamic<> &L) override
| From item's reaction forces to global reaction vector.
virtual void | IntStateScatterReactions (const unsigned int off_L, const ChVectorDynamic<> &L) override
| From global reaction vector to item's reaction forces.
virtual void | IntLoadResidual_CqL (const unsigned int off_L, ChVectorDynamic<> &R, const ChVectorDynamic<> &L, const double c) override
| Takes the term Cq'*L, scale and adds to R at given offset: R += c*Cq'*L.
virtual void | IntLoadConstraint_C (const unsigned int off, ChVectorDynamic<> &Qc, const double c, bool do_clamp, double recovery_clamp) override
| Takes the term C, scale and adds to Qc at given offset: Qc += c*C.
virtual void | IntToDescriptor (const unsigned int off_v, const ChStateDelta &v, const ChVectorDynamic<> &R, const unsigned int off_L, const ChVectorDynamic<> &L, const ChVectorDynamic<> &Qc) override
| Prepare variables and constraints to accommodate a solution:
virtual void | IntFromDescriptor (const unsigned int off_v, ChStateDelta &v, const unsigned int off_L, ChVectorDynamic<> &L) override
| After a solver solution, fetch values from variables and constraints into vectors:
virtual void | InjectConstraints (ChSystemDescriptor &descriptor) override
| Register with the given system descriptor any ChConstraint objects associated with this item.
virtual void | ConstraintsBiReset () override
| Sets to zero the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_C (double factor=1, double recovery_clamp=0.1, bool do_clamp=false) override
| Adds the current C (constraint violation) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_Ct (double factor=1) override
| Adds the current Ct (partial t-derivative, as in C_dt=0-> [Cq]*q_dt=-Ct) to the known term (b_i) of encapsulated ChConstraints.
virtual void | LoadConstraintJacobians () override
| Compute and load current Jacobians in encapsulated ChConstraint objects.
virtual void | ConstraintsFetch_react (double factor=1) override
| Fetches the reactions from the lagrangian multiplier (l_i) of encapsulated ChConstraints.
Public Member Functions inherited from chrono::ChLinkBase
| ChLinkBase (const ChLinkBase &other)
bool | IsValid ()
| Tells if the link data is currently valid.
void | SetValid (bool mon)
| Set the status of link validity.
bool | IsDisabled ()
| Tells if all constraints of this link are currently turned on or off by the user.
virtual void | SetDisabled (bool mdis)
| User can use this to enable/disable all the constraint of the link as desired.
bool | IsBroken ()
| Tells if the link is broken, for excess of pulling/pushing.
virtual void | SetBroken (bool mon)
| Set the 'broken' status vof this link.
virtual bool | IsActive () const override
| Return true if the link is currently active and thereofre included into the system solver.
virtual ChVectorDynamic | GetConstraintViolation () const
| Get the current constraint violations.
virtual bool | IsRequiringWaking ()
| Tells if this link requires that the connected ChBody objects must be waken if they are sleeping.
virtual ChFrame | GetVisualModelFrame (unsigned int nclone=0) const override
| Get the reference frame (expressed in and relative to the absolute frame) of the visual model.
Public Member Functions inherited from chrono::ChPhysicsItem
| ChPhysicsItem (const ChPhysicsItem &other)
ChSystem * | GetSystem () const
| Get the pointer to the parent ChSystem().
virtual void | SetSystem (ChSystem *m_system)
| Set the pointer to the parent ChSystem().
void | AddVisualModel (std::shared_ptr< ChVisualModel > model)
| Add an (optional) visualization model.
std::shared_ptr< ChVisualModel > | GetVisualModel () const
| Access the visualization model (if any).
void | AddVisualShape (std::shared_ptr< ChVisualShape > shape, const ChFrame<> &frame=ChFrame<>())
| Add the specified visual shape to the visualization model.
std::shared_ptr< ChVisualShape > | GetVisualShape (unsigned int i) const
| Access the specified visualization shape in the visualization model (if any).
void | AddVisualShapeFEA (std::shared_ptr< ChVisualShapeFEA > shapeFEA)
| Add the specified FEA visualization object to the visualization model.
std::shared_ptr< ChVisualShapeFEA > | GetVisualShapeFEA (unsigned int i) const
| Access the specified FEA visualization object in the visualization model (if any).
virtual unsigned int | GetNumVisualModelClones () const
| Return the number of clones of the visual model associated with this physics item.
void | AddCamera (std::shared_ptr< ChCamera > camera)
| Attach a ChCamera to this physical item.
std::vector< std::shared_ptr< ChCamera > > | GetCameras () const
| Get the set of cameras attached to this physics item.
virtual bool | IsCollisionEnabled () const
| Tell if the object is subject to collision.
virtual void | AddCollisionModelsToSystem (ChCollisionSystem *coll_sys) const
| Add to the provided collision system any collision models managed by this physics item.
virtual void | RemoveCollisionModelsFromSystem (ChCollisionSystem *coll_sys) const
| Remove from the provided collision system any collision models managed by this physics item.
virtual void | SyncCollisionModels ()
| Synchronize the position and bounding box of any collsion models managed by this physics item.
virtual ChAABB | GetTotalAABB ()
| Get the entire AABB axis-aligned bounding box of the object.
virtual void | GetCenter (ChVector3d &mcenter)
| Get a symbolic 'center' of the object.
virtual void | Setup ()
| This might recompute the number of coordinates, DOFs, constraints, in case this might change (ex in ChAssembly), as well as state offsets of contained items (ex in ChMesh).
virtual void | Update (bool update_assets=true)
| As above, but does not require updating of time-dependent data.
virtual void | ForceToRest ()
| Set zero speed (and zero accelerations) in state, without changing the position.
virtual unsigned int | GetNumCoordsPosLevel ()
| Get the number of coordinates at the position level.
virtual unsigned int | GetNumCoordsVelLevel ()
| Get the number of coordinates at the velocity level.
virtual unsigned int | GetNumConstraints ()
| Get the number of scalar constraints.
virtual unsigned int | GetNumConstraintsUnilateral ()
| Get the number of unilateral scalar constraints.
unsigned int | GetOffset_x ()
| Get offset in the state vector (position part).
unsigned int | GetOffset_w ()
| Get offset in the state vector (speed part).
unsigned int | GetOffset_L ()
| Get offset in the lagrangian multipliers.
void | SetOffset_x (const unsigned int moff)
| Set offset in the state vector (position part) Note: only the ChSystem::Setup function should use this.
void | SetOffset_w (const unsigned int moff)
| Set offset in the state vector (speed part) Note: only the ChSystem::Setup function should use this.
void | SetOffset_L (const unsigned int moff)
| Set offset in the lagrangian multipliers Note: only the ChSystem::Setup function should use this.
virtual void | IntStateGather (const unsigned int off_x, ChState &x, const unsigned int off_v, ChStateDelta &v, double &T)
| From item's state to global state vectors y={x,v} pasting the states at the specified offsets.
virtual void | IntStateScatter (const unsigned int off_x, const ChState &x, const unsigned int off_v, const ChStateDelta &v, const double T, bool full_update)
| From global state vectors y={x,v} to item's state (and update) fetching the states at the specified offsets.
virtual void | IntStateGatherAcceleration (const unsigned int off_a, ChStateDelta &a)
| From item's state acceleration to global acceleration vector.
virtual void | IntStateScatterAcceleration (const unsigned int off_a, const ChStateDelta &a)
| From global acceleration vector to item's state acceleration.
virtual void | IntStateIncrement (const unsigned int off_x, ChState &x_new, const ChState &x, const unsigned int off_v, const ChStateDelta &Dv)
| Computes x_new = x + Dt , using vectors at specified offsets.
virtual void | IntStateGetIncrement (const unsigned int off_x, const ChState &x_new, const ChState &x, const unsigned int off_v, ChStateDelta &Dv)
| Computes Dt = x_new - x, using vectors at specified offsets.
virtual void | IntLoadResidual_F (const unsigned int off, ChVectorDynamic<> &R, const double c)
| Takes the F force term, scale and adds to R at given offset: R += c*F.
virtual void | IntLoadResidual_Mv (const unsigned int off, ChVectorDynamic<> &R, const ChVectorDynamic<> &w, const double c)
| Takes the M*v term, multiplying mass by a vector, scale and adds to R at given offset: R += c*M*w.
virtual void | IntLoadLumpedMass_Md (const unsigned int off, ChVectorDynamic<> &Md, double &err, const double c)
| Adds the lumped mass to a Md vector, representing a mass diagonal matrix.
virtual void | IntLoadConstraint_Ct (const unsigned int off, ChVectorDynamic<> &Qc, const double c)
| Takes the term Ct, scale and adds to Qc at given offset: Qc += c*Ct.
virtual void | InjectVariables (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChVariable objects associated with this item.
virtual void | InjectKRMMatrices (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChKRMBlock objects associated with this item.
virtual void | LoadKRMMatrices (double Kfactor, double Rfactor, double Mfactor)
| Compute and load current stiffnes (K), damping (R), and mass (M) matrices in encapsulated ChKRMBlock objects.
virtual void | VariablesFbReset ()
| Sets the 'fb' part (the known term) of the encapsulated ChVariables to zero.
virtual void | VariablesFbLoadForces (double factor=1)
| Adds the current forces (applied to item) into the encapsulated ChVariables, in the 'fb' part: qf+=forces*factor.
virtual void | VariablesQbLoadSpeed ()
| Initialize the 'qb' part of the ChVariables with the current value of speeds.
virtual void | VariablesFbIncrementMq ()
| Adds M*q (masses multiplied current 'qb') to Fb, ex.
virtual void | VariablesQbSetSpeed (double step=0)
| Fetches the item speed (ex.
virtual void | VariablesQbIncrementPosition (double step)
| Increment item positions by the 'qb' part of the ChVariables, multiplied by a 'step' factor.
virtual void | ConstraintsBiLoad_Qc (double factor=1)
| Adds the current Qc (the vector of C_dtdt=0 -> [Cq]*q_dtdt=Qc ) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsFbLoadForces (double factor=1)
| Adds the current link-forces, if any, (caused by springs, etc.) to the 'fb' vectors of the ChVariables referenced by encapsulated ChConstraints.
Public Member Functions inherited from chrono::ChObj
| ChObj (const ChObj &other)
int | GetIdentifier () const
| Get the unique integer identifier of this object.
void | SetTag (int tag)
| Set an object integer tag (default: -1).
int | GetTag () const
| Get the tag of this object.
void | SetName (const std::string &myname)
| Set the name of this object.
const std::string & | GetName () const
| Get the name of this object.
double | GetChTime () const
| Gets the simulation time of this object.
void | SetChTime (double m_time)
| Sets the simulation time of this object.
virtual std::string & | ArchiveContainerName ()

## Additional Inherited Members
Protected Member Functions inherited from chrono::ChObj
int | GenerateUniqueIdentifier ()
Protected Attributes inherited from chrono::ChLinkBase
bool | disabled
| all constraints of link disabled because of user needs
bool | valid
| link data is valid
bool | broken
| link is broken because of excessive pulling/pushing.
Protected Attributes inherited from chrono::ChPhysicsItem
ChSystem * | system
| parent system
std::shared_ptr< ChVisualModelInstance > | vis_model_instance
| instantiated visualization model
std::vector< std::shared_ptr< ChCamera > > | cameras
| set of cameras
unsigned int | offset_x
| offset in vector of state (position part)
unsigned int | offset_w
| offset in vector of state (speed part)
unsigned int | offset_L
| offset in vector of lagrangian multipliers
Protected Attributes inherited from chrono::ChObj
double | ChTime
| object simulation time
std::string | m_name
| object name
int | m_identifier
| object unique identifier
int | m_tag
| user-supplied tag

## Member Function Documentation

## ◆ ArchiveIn()

void chrono::fea::ChLinkNodeFace::ArchiveIn | ( | ChArchiveIn & | archive_in | ) |
| overridevirtual

Method to allow deserialization of transient data from archives.

Reimplemented from chrono::ChLinkBase.

## ◆ ArchiveOut()

void chrono::fea::ChLinkNodeFace::ArchiveOut | ( | ChArchiveOut & | archive_out | ) |
| overridevirtual

Method to allow serialization of transient data to archives.

Reimplemented from chrono::ChLinkBase.

## ◆ Clone()

virtual ChLinkNodeFace * chrono::fea::ChLinkNodeFace::Clone | ( |  | ) | const
| inlineoverridevirtual

"Virtual" copy constructor (covariant return type).

Reimplemented from chrono::ChPhysicsItem.

## ◆ ConstraintsBiLoad_C()

void chrono::fea::ChLinkNodeFace::ConstraintsBiLoad_C | ( | double | factor = 1,
|  | double | recovery_clamp = 0.1,
|  | bool | do_clamp = false )
| overridevirtual

Adds the current C (constraint violation) to the known term (b_i) of encapsulated ChConstraints.

Reimplemented from chrono::ChPhysicsItem.

## ◆ ConstraintsBiLoad_Ct()

void chrono::fea::ChLinkNodeFace::ConstraintsBiLoad_Ct | ( | double | factor = 1 | ) |
| overridevirtual

Adds the current Ct (partial t-derivative, as in C_dt=0-> [Cq]*q_dt=-Ct) to the known term (b_i) of encapsulated ChConstraints.

Reimplemented from chrono::ChPhysicsItem.

## ◆ ConstraintsBiReset()

void chrono::fea::ChLinkNodeFace::ConstraintsBiReset | ( |  | ) |
| overridevirtual

Sets to zero the known term (b_i) of encapsulated ChConstraints.

Reimplemented from chrono::ChPhysicsItem.

## ◆ ConstraintsFetch_react()

void chrono::fea::ChLinkNodeFace::ConstraintsFetch_react | ( | double | factor = 1 | ) |
| overridevirtual

Fetches the reactions from the lagrangian multiplier (l_i) of encapsulated ChConstraints.

Mostly used after the solver provided the solution in ChConstraints. Also, should convert the reactions obtained from dynamical simulation, from link space to intuitive react_force and react_torque.

Reimplemented from chrono::ChPhysicsItem.

## ◆ GetAreaCoords()

virtual void chrono::fea::ChLinkNodeFace::GetAreaCoords | ( | double & | ms2,
|  | double & | ms3 ) const
| inlinevirtual

Get the area coordinates, as set with respect to B2 and B3.

(the third area coord follows automatically as 1-s2-s3).

## ◆ GetNumAffectedCoords()

virtual unsigned int chrono::fea::ChLinkNodeFace::GetNumAffectedCoords | ( |  | ) |
| inlineoverridevirtual

Get the number of scalar variables affected by constraints in this link.

Implements chrono::ChLinkBase.

## ◆ GetNumConstraintsBilateral()

virtual unsigned int chrono::fea::ChLinkNodeFace::GetNumConstraintsBilateral | ( |  | ) |
| inlineoverridevirtual

Number of scalar constraints.

Reimplemented from chrono::ChPhysicsItem.

## ◆ Initialize()

int chrono::fea::ChLinkNodeFace::Initialize | ( | std::shared_ptr< ChNodeFEAxyz > | anodeA,
|  | std::shared_ptr< ChNodeFEAxyz > | anodeB1,
|  | std::shared_ptr< ChNodeFEAxyz > | anodeB2,
|  | std::shared_ptr< ChNodeFEAxyz > | anodeB3 )
| virtual

Initialize this constraint, given the node and the triangle to join.

The attachment position is the actual position of the node. All nodes must belong to the same ChSystem.

Parameters

  anodeA | xyz node (point) to join
  anodeB1 | triangle: corner n.1
  anodeB2 | triangle: corner n.2
  anodeB3 | triangle: corner n.3

## ◆ InjectConstraints()

void chrono::fea::ChLinkNodeFace::InjectConstraints | ( | ChSystemDescriptor & | descriptor | ) |
| overridevirtual

Register with the given system descriptor any ChConstraint objects associated with this item.

Reimplemented from chrono::ChPhysicsItem.

## ◆ IntFromDescriptor()

void chrono::fea::ChLinkNodeFace::IntFromDescriptor | ( | const unsigned int | off_v,
|  | ChStateDelta & | v,
|  | const unsigned int | off_L,
|  | ChVectorDynamic<> & | L )
| overridevirtual

After a solver solution, fetch values from variables and constraints into vectors:

Parameters

  off_v | offset for v
  v | vector to where the q 'unknowns' term of the variables will be copied
  off_L | offset for L
  L | vector to where L 'lagrangian ' term of the constraints will be copied

Reimplemented from chrono::ChPhysicsItem.

## ◆ IntLoadConstraint_C()

void chrono::fea::ChLinkNodeFace::IntLoadConstraint_C | ( | const unsigned int | off,
|  | ChVectorDynamic<> & | Qc,
|  | const double | c,
|  | bool | do_clamp,
|  | double | recovery_clamp )
| overridevirtual

Takes the term C, scale and adds to Qc at given offset: Qc += c*C.

Parameters

  off | offset in Qc residual
  Qc | result: the Qc residual, Qc += c*C
  c | a scaling factor
  do_clamp | apply clamping to c*C?
  recovery_clamp | value for min/max clamping of c*C

Reimplemented from chrono::ChPhysicsItem.

## ◆ IntLoadResidual_CqL()

void chrono::fea::ChLinkNodeFace::IntLoadResidual_CqL | ( | const unsigned int | off_L,
|  | ChVectorDynamic<> & | R,
|  | const ChVectorDynamic<> & | L,
|  | const double | c )
| overridevirtual

Takes the term Cq'*L, scale and adds to R at given offset: R += c*Cq'*L.

Parameters

  off_L | offset in L multipliers
  R | result: the R residual, R += c*Cq'*L
  L | the L vector
  c | a scaling factor

Reimplemented from chrono::ChPhysicsItem.

## ◆ IntStateGatherReactions()

void chrono::fea::ChLinkNodeFace::IntStateGatherReactions | ( | const unsigned int | off_L,
|  | ChVectorDynamic<> & | L )
| overridevirtual

From item's reaction forces to global reaction vector.

Parameters

  off_L | offset in L vector
  L | L vector of reaction forces

Reimplemented from chrono::ChPhysicsItem.

## ◆ IntStateScatterReactions()

void chrono::fea::ChLinkNodeFace::IntStateScatterReactions | ( | const unsigned int | off_L,
|  | const ChVectorDynamic<> & | L )
| overridevirtual

From global reaction vector to item's reaction forces.

Parameters

  off_L | offset in L vector
  L | L vector of reaction forces

Reimplemented from chrono::ChPhysicsItem.

## ◆ IntToDescriptor()

void chrono::fea::ChLinkNodeFace::IntToDescriptor | ( | const unsigned int | off_v,
|  | const ChStateDelta & | v,
|  | const ChVectorDynamic<> & | R,
|  | const unsigned int | off_L,
|  | const ChVectorDynamic<> & | L,
|  | const ChVectorDynamic<> & | Qc )
| overridevirtual

Prepare variables and constraints to accommodate a solution:

Parameters

  off_v | offset for v and R
  v | vector copied into the q 'unknowns' term of the variables
  R | vector copied into the F 'force' term of the variables
  off_L | offset for L and Qc
  L | vector copied into the L 'lagrangian ' term of the constraints
  Qc | vector copied into the Qb 'constraint' term of the constraints

Reimplemented from chrono::ChPhysicsItem.

## ◆ LoadConstraintJacobians()

void chrono::fea::ChLinkNodeFace::LoadConstraintJacobians | ( |  | ) |
| overridevirtual

Compute and load current Jacobians in encapsulated ChConstraint objects.

Reimplemented from chrono::ChPhysicsItem.

## ◆ SetAreaCoords()

virtual void chrono::fea::ChLinkNodeFace::SetAreaCoords | ( | const double | ms2,
|  | const double | ms3 )
| inlinevirtual

Set the area coordinates to specify where the point A is connected on triangle.

These are 0..1 values, one respect to point B2, the other respect to B3 (the third area coord follows automatically as 1-s2-s3). The Initialize() function initialize this automatically.

## ◆ SetOffset()

virtual void chrono::fea::ChLinkNodeFace::SetOffset | ( | const double | md | ) |
| inlinevirtual

Set an optional offset of the point with respect to triangle, along triangle normal.

Note that it is better to avoid large offsets. Better if offset is zero. The Initialize() function initialize this automatically.

## ◆ Update()

void chrono::fea::ChLinkNodeFace::Update | ( | double | mytime,
|  | bool | update_assets = true )
| overridevirtual

Update all auxiliary data of the gear transmission at given time.

Reimplemented from chrono::ChPhysicsItem.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono/fea/ChLinkNodeFace.h
- D:/W/B/src/chrono-9.0.1/src/chrono/fea/ChLinkNodeFace.cpp